Index: /GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.vcproj
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.vcproj	(revision 1264)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.vcproj	(revision 1272)
@@ -20,5 +20,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="..\include;..\src;&quot;$(CG_INC_PATH)&quot;;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;&quot;$(BOOST_INCLUDE)&quot;"
+				AdditionalIncludeDirectories="..\include;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost"
 				PreprocessorDefinitions="WIN32;_DEBUG;_CONSOLE"
 				MinimalRebuild="TRUE"
@@ -122,7 +122,10 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				Optimization="0"
-				AdditionalIncludeDirectories="..\include;&quot;$(BOOST_INCLUDE)&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\src;&quot;$(CG_INC_PATH)&quot;;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\MultiLevelRayTracing"
-				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE"
+				Optimization="3"
+				GlobalOptimizations="TRUE"
+				FavorSizeOrSpeed="1"
+				OptimizeForProcessor="3"
+				AdditionalIncludeDirectories="..\include;..\..\..\..\..\..\NonGTP\Boost;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\MultiLevelRayTracing"
+				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL"
 				RuntimeLibrary="2"
 				RuntimeTypeInfo="TRUE"
@@ -135,8 +138,8 @@
 			<Tool
 				Name="VCLinkerTool"
-				AdditionalDependencies="xerces-c_2.lib glew32.lib zdll.lib zziplib.lib devil.lib glut32.lib OpenGL32.Lib glu32.lib cg.lib cgGL.lib Preprocessor.lib"
+				AdditionalDependencies="xerces-c_2.lib glew32.lib zdll.lib zziplib.lib devil.lib glut32.lib OpenGL32.Lib glu32.lib cg.lib cgGL.lib Preprocessor.lib RTWorld.lib RTScene.lib"
 				OutputFile="$(OutDir)/Preprocessor.exe"
 				LinkIncremental="1"
-				AdditionalLibraryDirectories="..\support\xercesc\lib\;..\support\zlib\lib\;..\support\devil\lib;..\include;..\src\GL;&quot;$(CG_LIB_PATH)&quot;;..\lib\release;..\..\Preprocessing\lib\release;&quot;$(BOOST_LIB)&quot;;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;..\..\Preprocessing\MultiLevelRayTracing\RTScene\Release;..\..\Preprocessing\MultiLevelRayTracing\RTWorld\Release"
+				AdditionalLibraryDirectories="..\src\mlrt;&quot;$(CG_LIB_PATH)&quot;;..\src\GL;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;..\..\Preprocessing\MultiLevelRayTracing\RTScene\Release;..\..\Preprocessing\MultiLevelRayTracing\RTWorld\Release"
 				GenerateDebugInformation="FALSE"
 				SubSystem="1"
@@ -174,6 +177,6 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				Optimization="0"
-				AdditionalIncludeDirectories="..\include;&quot;$(BOOST_INCLUDE)&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces"
+				Optimization="3"
+				AdditionalIncludeDirectories="..\include;..\..\..\..\..\..\NonGTP\Boost;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL"
 				RuntimeLibrary="2"
@@ -190,5 +193,5 @@
 				OutputFile="../bin/release/Preprocessor.exe"
 				LinkIncremental="1"
-				AdditionalLibraryDirectories="..\src\GL;..\lib\release;..\..\Preprocessing\lib\release;&quot;$(BOOST_LIB)&quot;;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;..\MultiLevelRayTracing\RTScene\Release;..\MultiLevelRayTracing\RTWorld\Release"
+				AdditionalLibraryDirectories="..\src\GL;..\lib\release;..\..\Preprocessing\lib\release;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;..\MultiLevelRayTracing\RTScene\Release;..\MultiLevelRayTracing\RTWorld\Release"
 				GenerateDebugInformation="FALSE"
 				SubSystem="1"
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/X3dParser.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/X3dParser.cpp	(revision 1221)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/X3dParser.cpp	(revision 1272)
@@ -224,4 +224,5 @@
 	 }
 
+	 
 	 //-- each polygon is one single mesh
 	 if (mLoadPolygonsAsMeshes)
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.icproj
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.icproj	(revision 1272)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.icproj	(revision 1272)
@@ -0,0 +1,779 @@
+<?xml version="1.0" encoding="Windows-1252"?>
+<VisualStudioProject 
+	ProjectType="Intel C++ Project"
+	Version="9.0"
+	Name="Preprocessor"
+	ProjectGUID="{E240C450-69B9-4B01-A6FD-88F9466A3A88}"
+	Keyword="Win32Proj"
+	VCNestedProjectGUID="{EABCE292-D598-4600-A1C9-2591E7D62FDA}"
+	VCNestedProjectFileName="Preprocessor.vcproj">
+	<Platforms>
+		<Platform 
+			Name="Win32"/>
+	</Platforms>
+	<Configurations>
+		<Configuration 
+			Name="Debug|Win32">
+			<Tool 
+				Name="GeneralTool"
+				OutputDirectory="..\lib\$(ConfigurationName)"
+				IntermediateDirectory="..\obj\$(ConfigurationName)"
+				ConfigurationType="4"
+				CharacterSet="2"/>
+			<Tool 
+				Name="CppCmplrTool"
+				Optimization="0"
+				AdditionalIncludeDirectories="..\include;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost"
+				PreprocessorDefinitions="WIN32;_DEBUG;_LIB;"
+				MinimalRebuild="TRUE"
+				BasicRuntimeChecks="3"
+				RuntimeLibrary="3"
+				RuntimeTypeInfo="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool 
+				Name="CustomTool"/>
+			<Tool 
+				Name="LibrarianTool"/>
+			<Tool 
+				Name="MidlCmplrTool"/>
+			<Tool 
+				Name="PostBuildEventTool"/>
+			<Tool 
+				Name="PreBuildEventTool"/>
+			<Tool 
+				Name="PreLinkEventTool"/>
+			<Tool 
+				Name="ResCmplrTool"/>
+			<Tool 
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool 
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool 
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool 
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration 
+			Name="Release|Win32">
+			<Tool 
+				Name="GeneralTool"
+				OutputDirectory="..\lib\$(ConfigurationName)"
+				IntermediateDirectory="..\obj\$(ConfigurationName)"
+				ConfigurationType="4"
+				CharacterSet="2"/>
+			<Tool 
+				Name="CppCmplrTool"
+				Optimization="0"
+				InlineFunctionExpansion="0"
+				FavorSizeOrSpeed="0"
+				OptimizeForWindowsApplication="TRUE"
+				AdditionalIncludeDirectories="..\include;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost"
+				PreprocessorDefinitions="WIN32;NDEBUG;_LIB"
+				ExceptionHandling="TRUE"
+				RuntimeLibrary="2"
+				DisableLanguageExtensions="FALSE"
+				ForceConformanceInForLoopScope="FALSE"
+				RuntimeTypeInfo="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="2"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool 
+				Name="CustomTool"/>
+			<Tool 
+				Name="LibrarianTool"/>
+			<Tool 
+				Name="MidlCmplrTool"/>
+			<Tool 
+				Name="PostBuildEventTool"/>
+			<Tool 
+				Name="PreBuildEventTool"/>
+			<Tool 
+				Name="PreLinkEventTool"/>
+			<Tool 
+				Name="ResCmplrTool"/>
+			<Tool 
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool 
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool 
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool 
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration 
+			Name="mlrt|Win32">
+			<Tool 
+				Name="GeneralTool"
+				OutputDirectory="$(ConfigurationName)"
+				IntermediateDirectory="$(ConfigurationName)"
+				ConfigurationType="4"
+				CharacterSet="2"/>
+			<Tool 
+				Name="CppCmplrTool"
+				Optimization="3"
+				GlobalOptimizations="TRUE"
+				InlineFunctionExpansion="0"
+				FavorSizeOrSpeed="1"
+				OptimizeForProcessor="3"
+				OptimizeForWindowsApplication="TRUE"
+				AdditionalIncludeDirectories="..\include;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\..\Preprocessing\MultiLevelRayTracing"
+				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL"
+				ExceptionHandling="TRUE"
+				RuntimeLibrary="2"
+				DisableLanguageExtensions="FALSE"
+				ForceConformanceInForLoopScope="FALSE"
+				RuntimeTypeInfo="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="2"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool 
+				Name="CustomTool"/>
+			<Tool 
+				Name="LibrarianTool"/>
+			<Tool 
+				Name="MidlCmplrTool"/>
+			<Tool 
+				Name="PostBuildEventTool"/>
+			<Tool 
+				Name="PreBuildEventTool"/>
+			<Tool 
+				Name="PreLinkEventTool"/>
+			<Tool 
+				Name="ResCmplrTool"/>
+			<Tool 
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool 
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool 
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool 
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration 
+			Name="Release_Internal|Win32">
+			<Tool 
+				Name="GeneralTool"
+				OutputDirectory="$(ConfigurationName)"
+				IntermediateDirectory="$(ConfigurationName)"
+				ConfigurationType="4"
+				CharacterSet="2"/>
+			<Tool 
+				Name="CppCmplrTool"
+				Optimization="0"
+				InlineFunctionExpansion="0"
+				FavorSizeOrSpeed="0"
+				OptimizeForWindowsApplication="TRUE"
+				AdditionalIncludeDirectories="..\include;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\src;&quot;$(CG_INC_PATH)&quot;;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;&quot;$(BOOST_INCLUDE)&quot;;..\..\Preprocessing\MultiLevelRayTracing"
+				PreprocessorDefinitions="WIN32;NDEBUG;_LIB"
+				ExceptionHandling="TRUE"
+				RuntimeLibrary="2"
+				DisableLanguageExtensions="FALSE"
+				ForceConformanceInForLoopScope="FALSE"
+				RuntimeTypeInfo="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="2"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool 
+				Name="CustomTool"/>
+			<Tool 
+				Name="LibrarianTool"/>
+			<Tool 
+				Name="MidlCmplrTool"/>
+			<Tool 
+				Name="PostBuildEventTool"/>
+			<Tool 
+				Name="PreBuildEventTool"/>
+			<Tool 
+				Name="PreLinkEventTool"/>
+			<Tool 
+				Name="ResCmplrTool"/>
+			<Tool 
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool 
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool 
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool 
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration 
+			Name="Release Internal|Win32">
+			<Tool 
+				Name="GeneralTool"
+				OutputDirectory="$(ConfigurationName)"
+				IntermediateDirectory="$(ConfigurationName)"
+				ConfigurationType="4"
+				CharacterSet="2"/>
+			<Tool 
+				Name="CppCmplrTool"
+				Optimization="3"
+				InlineFunctionExpansion="0"
+				FavorSizeOrSpeed="0"
+				OptimizeForProcessor="3"
+				OptimizeForWindowsApplication="TRUE"
+				AdditionalIncludeDirectories="..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\MultiLevelRayTracing"
+				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL"
+				ExceptionHandling="TRUE"
+				RuntimeLibrary="2"
+				DisableLanguageExtensions="FALSE"
+				ForceConformanceInForLoopScope="FALSE"
+				RuntimeTypeInfo="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="2"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool 
+				Name="CustomTool"/>
+			<Tool 
+				Name="LibrarianTool"
+				OutputFile="../lib/Release/$(ProjectName).lib"/>
+			<Tool 
+				Name="MidlCmplrTool"/>
+			<Tool 
+				Name="PostBuildEventTool"/>
+			<Tool 
+				Name="PreBuildEventTool"/>
+			<Tool 
+				Name="PreLinkEventTool"/>
+			<Tool 
+				Name="ResCmplrTool"/>
+			<Tool 
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool 
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool 
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool 
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+	</Configurations>
+	<References>
+	</References>
+	<Files>
+		<Filter 
+			Name="Source Files"
+			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm;asmx"
+			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}">
+			<File 
+				RelativePath="..\src\AxisAlignedBox3.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\AxisAlignedBox3.h">
+			</File>
+			<File 
+				RelativePath="..\src\Beam.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Beam.h">
+			</File>
+			<File 
+				RelativePath="..\src\BoostPreprocessorThread.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\BoostPreprocessorThread.h">
+			</File>
+			<File 
+				RelativePath="..\src\BoundingBoxConverter.h">
+			</File>
+			<File 
+				RelativePath=".\BvHierarchy.cpp">
+			</File>
+			<File 
+				RelativePath=".\BvHierarchy.h">
+			</File>
+			<File 
+				RelativePath="..\src\Camera.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Camera.h">
+			</File>
+			<File 
+				RelativePath="..\src\common.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\common.h">
+			</File>
+			<File 
+				RelativePath="..\src\Containers.h">
+			</File>
+			<File 
+				RelativePath="..\src\dual_depth.cg">
+			</File>
+			<File 
+				RelativePath="..\src\Environment.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Environment.h">
+			</File>
+			<File 
+				RelativePath="..\src\ExactPreprocessor.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\ExactPreprocessor.h">
+			</File>
+			<File 
+				RelativePath="..\src\Exporter.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Exporter.h">
+			</File>
+			<File 
+				RelativePath="..\src\FlexibleHeap.h">
+			</File>
+			<File 
+				RelativePath="..\src\glInterface.h">
+			</File>
+			<File 
+				RelativePath="..\src\GzBinFileInputStream.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\GzBinFileInputStream.h">
+			</File>
+			<File 
+				RelativePath="..\src\GzFileInputSource.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\GzFileInputSource.h">
+			</File>
+			<File 
+				RelativePath="..\src\gzstream.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\gzstream.h">
+			</File>
+			<File 
+				RelativePath="..\src\Halton.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Halton.h">
+			</File>
+			<File 
+				RelativePath=".\HierarchyManager.cpp">
+			</File>
+			<File 
+				RelativePath=".\HierarchyManager.h">
+			</File>
+			<File 
+				RelativePath="..\src\Intersectable.h">
+			</File>
+			<File 
+				RelativePath="..\src\KdIntersectable.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\KdIntersectable.h">
+			</File>
+			<File 
+				RelativePath="..\src\KdTree.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\KdTree.h">
+			</File>
+			<File 
+				RelativePath="..\src\LogManager.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\LogManager.h">
+			</File>
+			<File 
+				RelativePath="..\src\Material.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Material.h">
+			</File>
+			<File 
+				RelativePath="..\src\Matrix4x4.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Matrix4x4.h">
+			</File>
+			<File 
+				RelativePath="..\src\Mesh.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Mesh.h">
+			</File>
+			<File 
+				RelativePath="..\src\MeshKdTree.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\MeshKdTree.h">
+			</File>
+			<File 
+				RelativePath="..\src\MutualVisibility.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\MutualVisibility.h">
+			</File>
+			<File 
+				RelativePath="..\src\ObjParser.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\ObjParser.h">
+			</File>
+			<File 
+				RelativePath="..\src\OcclusionQuery.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\OcclusionQuery.h">
+			</File>
+			<File 
+				RelativePath=".\OspTree.cpp">
+			</File>
+			<File 
+				RelativePath=".\OspTree.h">
+			</File>
+			<File 
+				RelativePath="..\src\Parser.h">
+			</File>
+			<File 
+				RelativePath="..\src\Plane3.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Plane3.h">
+			</File>
+			<File 
+				RelativePath="..\src\ply.h">
+			</File>
+			<File 
+				RelativePath="..\src\plyfile.c">
+			</File>
+			<File 
+				RelativePath="..\src\PlyParser.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\PlyParser.h">
+			</File>
+			<File 
+				RelativePath="..\src\Polygon3.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Polygon3.h">
+			</File>
+			<File 
+				RelativePath="..\src\Polytope.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Polytope.h">
+			</File>
+			<File 
+				RelativePath="..\src\Preprocessor.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Preprocessor.h">
+				<FileConfiguration 
+					Name="Release|Win32">
+					<Tool 
+						Name="CustomTool"
+						Description=""
+						CommandLine=""
+						Outputs=""/>
+				</FileConfiguration>
+				<FileConfiguration 
+					Name="mlrt|Win32">
+					<Tool 
+						Name="CustomTool"
+						Description=""
+						CommandLine=""
+						Outputs=""/>
+				</FileConfiguration>
+				<FileConfiguration 
+					Name="Release_Internal|Win32">
+					<Tool 
+						Name="CustomTool"
+						Description=""
+						CommandLine=""
+						Outputs=""/>
+				</FileConfiguration>
+				<FileConfiguration 
+					Name="Release Internal|Win32">
+					<Tool 
+						Name="CustomTool"
+						Description=""
+						CommandLine=""
+						Outputs=""/>
+				</FileConfiguration>
+			</File>
+			<File 
+				RelativePath="..\src\PreprocessorThread.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\PreprocessorThread.h">
+				<FileConfiguration 
+					Name="Release|Win32">
+					<Tool 
+						Name="CustomTool"
+						Description=""
+						CommandLine=""
+						Outputs=""/>
+				</FileConfiguration>
+				<FileConfiguration 
+					Name="mlrt|Win32">
+					<Tool 
+						Name="CustomTool"
+						Description=""
+						CommandLine=""
+						Outputs=""/>
+				</FileConfiguration>
+				<FileConfiguration 
+					Name="Release_Internal|Win32">
+					<Tool 
+						Name="CustomTool"
+						Description=""
+						CommandLine=""
+						Outputs=""/>
+				</FileConfiguration>
+				<FileConfiguration 
+					Name="Release Internal|Win32">
+					<Tool 
+						Name="CustomTool"
+						Description=""
+						CommandLine=""
+						Outputs=""/>
+				</FileConfiguration>
+			</File>
+			<File 
+				RelativePath="..\src\Pvs.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Pvs.h">
+			</File>
+			<File 
+				RelativePath="..\src\Ray.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Ray.h">
+			</File>
+			<File 
+				RelativePath="..\src\RayInfo.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\RayInfo.h">
+			</File>
+			<File 
+				RelativePath="..\src\Rectangle3.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Rectangle3.h">
+			</File>
+			<File 
+				RelativePath="..\src\RenderSampler.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\RenderSampler.h">
+			</File>
+			<File 
+				RelativePath="..\src\RenderSimulator.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\RenderSimulator.h">
+			</File>
+			<File 
+				RelativePath="..\src\ResourceManager.h">
+			</File>
+			<File 
+				RelativePath="..\src\RssPreprocessor.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\RssPreprocessor.h">
+			</File>
+			<File 
+				RelativePath="..\src\RssTree.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\RssTree.h">
+			</File>
+			<File 
+				RelativePath="..\src\SamplingPreprocessor.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\SamplingPreprocessor.h">
+			</File>
+			<File 
+				RelativePath="..\src\SamplingStrategy.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\SamplingStrategy.h">
+			</File>
+			<File 
+				RelativePath="..\src\SceneGraph.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\SceneGraph.h">
+			</File>
+			<File 
+				RelativePath="..\src\Statistics.h">
+			</File>
+			<File 
+				RelativePath=".\SubdivisionCandidate.h">
+			</File>
+			<File 
+				RelativePath="..\src\Tetrahedron3.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Tetrahedron3.h">
+			</File>
+			<File 
+				RelativePath="..\src\Triangle3.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Triangle3.h">
+			</File>
+			<File 
+				RelativePath="..\src\UnigraphicsParser.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\UnigraphicsParser.h">
+			</File>
+			<File 
+				RelativePath="..\src\Vector3.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Vector3.h">
+			</File>
+			<File 
+				RelativePath="..\src\ViewCell.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\ViewCell.h">
+			</File>
+			<File 
+				RelativePath="..\src\ViewCellBsp.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\ViewCellBsp.h">
+			</File>
+			<File 
+				RelativePath="..\src\ViewCellsManager.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\ViewCellsManager.h">
+			</File>
+			<File 
+				RelativePath="..\src\ViewCellsParser.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\ViewCellsParser.h">
+			</File>
+			<File 
+				RelativePath="..\src\ViewCellsParserXerces.h">
+			</File>
+			<File 
+				RelativePath="..\src\VrmlExporter.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\VrmlExporter.h">
+			</File>
+			<File 
+				RelativePath="..\src\VspBspTree.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\VspBspTree.h">
+			</File>
+			<File 
+				RelativePath=".\VspTree.cpp">
+			</File>
+			<File 
+				RelativePath=".\VspTree.h">
+			</File>
+			<File 
+				RelativePath="..\src\VssPreprocessor.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\VssPreprocessor.h">
+			</File>
+			<File 
+				RelativePath="..\src\VssRay.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\VssRay.h">
+			</File>
+			<File 
+				RelativePath="..\src\VssTree.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\VssTree.h">
+			</File>
+			<File 
+				RelativePath="..\src\X3dExporter.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\X3dExporter.h">
+			</File>
+			<File 
+				RelativePath="..\src\X3dParser.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\X3dParser.h">
+			</File>
+			<File 
+				RelativePath="..\src\X3dParserXerces.h">
+			</File>
+		</Filter>
+		<Filter 
+			Name="Header Files"
+			Filter="h;hpp;hxx;hm;inl;inc;xsd"
+			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}">
+			<File 
+				RelativePath="..\include\AxisAlignedBox3.h">
+			</File>
+			<File 
+				RelativePath="..\include\Containers.h">
+			</File>
+			<File 
+				RelativePath="..\include\ExactPreprocessor.h">
+			</File>
+			<File 
+				RelativePath="..\include\KdTree.h">
+			</File>
+			<File 
+				RelativePath="..\include\Mesh.h">
+			</File>
+			<File 
+				RelativePath="..\include\Plane3.h">
+			</File>
+			<File 
+				RelativePath="..\include\Preprocessor.h">
+			</File>
+			<File 
+				RelativePath="..\include\SamplingPreprocessor.h">
+			</File>
+			<File 
+				RelativePath="..\include\SceneGraph.h">
+			</File>
+			<File 
+				RelativePath="..\include\Vector3.h">
+			</File>
+			<File 
+				RelativePath="..\include\ViewCell.h">
+			</File>
+		</Filter>
+		<Filter 
+			Name="Renderer"
+			Filter="">
+			<File 
+				RelativePath="..\src\GlRenderer.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\GlRenderer.h">
+			</File>
+			<File 
+				RelativePath="..\src\Renderer.cpp">
+			</File>
+			<File 
+				RelativePath="..\src\Renderer.h">
+			</File>
+		</Filter>
+		<File 
+			RelativePath=".\VTune\Preprocessor.vpj">
+		</File>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>
+
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 1264)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 1272)
@@ -238,8 +238,10 @@
 
 		if (mRayCastMethod == Preprocessor::INTEL_RAYCASTER)
-			result = parser->ParseFile(filename, &mSceneGraph->mRoot, mLoadPolygonsAsMeshes, &mFaceParents);
+		  result = parser->ParseFile(filename, &mSceneGraph->mRoot,
+									 mLoadPolygonsAsMeshes,
+									 &mFaceParents);
 		else
-			result = parser->ParseFile(filename, &mSceneGraph->mRoot, mLoadPolygonsAsMeshes);
-
+		  result = parser->ParseFile(filename, &mSceneGraph->mRoot, mLoadPolygonsAsMeshes);
+		
 		delete parser;
 
@@ -248,22 +250,32 @@
 		mSceneGraph->mRoot = new SceneGraphNode;
 		for (int i= 0; i < filenames.size(); i++) {
-			if (strstr(filenames[i].c_str(), ".x3d"))
-				parser = new X3dParser;
-			else 
-				parser = new UnigraphicsParser;
-						
-			SceneGraphNode *node;
-			if (parser->ParseFile(filenames[i], &node)) {
-				mSceneGraph->mRoot->mChildren.push_back(node);
-				// at least one file parsed
-				result = true;
-			}
-			delete parser;
+		  if (strstr(filenames[i].c_str(), ".x3d"))
+			parser = new X3dParser;
+		  else 
+			parser = new UnigraphicsParser;
+		  
+		  SceneGraphNode *node;
+		  bool success;
+		  
+		  if (mRayCastMethod == Preprocessor::INTEL_RAYCASTER)
+			success = parser->ParseFile(filename, &node,
+										mLoadPolygonsAsMeshes,
+										&mFaceParents);
+		  else
+			success = parser->ParseFile(filename, &node, mLoadPolygonsAsMeshes);
+		  
+		  if (success) {
+			mSceneGraph->mRoot->mChildren.push_back(node);
+			// at least one file parsed
+			result = true;
+		  }
+		  
+		  delete parser;
 		}
 	}
 	
-
+	
 	if (result) 
-	{
+	  {
 		// HACK 
 		if (ADDITIONAL_GEOMETRY_HACK)
@@ -769,5 +781,6 @@
 	case INTEL_RAYCASTER:
 #ifdef GTP_INTERNAL
-		return mlrtaLoadAS(externKdTree.c_str());
+	  cout<<"Ray Cast file: "<<externKdTree<<endl;
+	  return mlrtaLoadAS(externKdTree.c_str());
 #endif
 	case INTERNAL_RAYCASTER:
@@ -851,5 +864,5 @@
 	float pforg[3];
 	float pfdir[3];
-	//double pfnorm[3];
+	double pfnorm[3];
 
 	pforg[0] = viewPoint[0]; pforg[1] = viewPoint[1]; pforg[2] = viewPoint[2];
@@ -895,135 +908,95 @@
 								  )
 {
-    int hits = 0;
-	static Ray ray;
-
-	AxisAlignedBox3 sbox = box;
-	sbox.Enlarge(Vector3(-Limits::Small));
-
-	if (!sbox.IsInside(viewPoint))
+
+  int hits = 0;
+  static Ray ray;
+  Intersectable *objectA, *objectB;
+  Vector3 pointA, pointB;
+
+  //  AxisAlignedBox3 box = Union(mKdTree->GetBox(), mViewCellsManager->GetViewSpaceBox());
+  
+
+  AxisAlignedBox3 sbox = box;
+  sbox.Enlarge(Vector3(-Limits::Small));
+  if (!sbox.IsInside(viewPoint))
+	return 0;
+	
+  SetupRay(ray, viewPoint, direction);
+  ray.mFlags &= ~Ray::CULL_BACKFACES;
+
+  // cast ray to KD tree to find intersection with other objects
+  float bsize = Magnitude(box.Size());
+  
+  
+  if (mKdTree->CastRay(ray)) {
+	objectA = ray.intersections[0].mObject;
+	pointA = ray.Extrap(ray.intersections[0].mT);
+	if (mDetectEmptyViewSpace)
+	  if (DotProd(ray.intersections[0].mNormal, direction) >= 0) {
+		// discard the sample
 		return 0;
-	
-	SetupRay(ray, viewPoint, direction);
-	
-	// cast ray to KD tree to find intersection with other objects
-	Intersectable *objectA, *objectB;
-	
-	Vector3 pointA;
-	Vector3 pointB;
-
-	//float bsize = Magnitude(box.Size());
-	if (!mDetectEmptyViewSpace)
-		ray.mFlags &= ~Ray::CULL_BACKFACES;
+	  }
+	
+  } else {
+	objectA = NULL;
+	// compute intersection with the scene bounding box
+	float tmin, tmax;
+	if (box.ComputeMinMaxT(ray, &tmin, &tmax) && tmin < tmax)
+	  pointA = ray.Extrap(tmax);
 	else
-		ray.mFlags |= Ray::CULL_BACKFACES;
-
-	if (mKdTree->CastRay(ray)) 
-	{
-		objectA = ray.intersections[0].mObject;
-		pointA = ray.Extrap(ray.intersections[0].mT);
-	} 
-	else 
-	{
-		objectA = NULL;
-		// compute intersection with the scene bounding box
-		float tmin, tmax;
-		if (box.ComputeMinMaxT(ray, &tmin, &tmax) && tmin < tmax)
-			pointA = ray.Extrap(tmax);
-		else
-			return 0;
-	}
-
-	// matt: point A could be undefined?
-
-	// cast ray into opposite direction
-	if (1 && mDetectEmptyViewSpace) {
-		SetupRay(ray, pointA, -direction);
-	} else
-		SetupRay(ray, viewPoint, -direction);
-  
-	if (!mDetectEmptyViewSpace)
-		ray.mFlags &= ~Ray::CULL_BACKFACES;
+	  return 0;
+  }
+
+  
+  SetupRay(ray, viewPoint, -direction);
+  ray.mFlags &= ~Ray::CULL_BACKFACES;
+  
+  if (mKdTree->CastRay(ray)) {
+	objectB = ray.intersections[0].mObject;
+	pointB = ray.Extrap(ray.intersections[0].mT);
+	if (mDetectEmptyViewSpace)
+	  if (DotProd(ray.intersections[0].mNormal, direction) <= 0) {
+		// discard the sample
+		return 0;
+	  }
+  } else {
+	objectB = NULL;
+	float tmin, tmax;
+	if (box.ComputeMinMaxT(ray, &tmin, &tmax) && tmin < tmax)
+	  pointB = ray.Extrap(tmax);
 	else
-		ray.mFlags |= Ray::CULL_BACKFACES;
-
-	if (mKdTree->CastRay(ray)) 
-	{
-		objectB = ray.intersections[0].mObject;
-		pointB = ray.Extrap(ray.intersections[0].mT);
-	} 
-	else 
-	{
-		objectB = NULL;
-		float tmin, tmax;
-		
-		if (box.ComputeMinMaxT(ray, &tmin, &tmax) && tmin < tmax)
-			pointB = ray.Extrap(tmax);
-		else
-			return 0;
-	}
-  
-	//bool thesame = objectA && (objectA == objectB);
-	
-	//  if (objectA == NULL && objectB != NULL) {
-	if (1 && mDetectEmptyViewSpace) 
-	{
-		// cast again to ensure that there is no objectA
-		SetupRay(ray, pointB, direction);
-		ray.mFlags |= Ray::CULL_BACKFACES;
-		
-		if (mKdTree->CastRay(ray)) 
-		{
-	 		objectA = ray.intersections[0].mObject;
-			pointA = ray.Extrap(ray.intersections[0].mT);
-		}
-	}
-
-  
-	VssRay *vssRay  = NULL;
-
-	bool validSample = (objectA != objectB);
-	
-	//if (validSample && thesame) Debug << "warning!!" << endl;
-
-	if (0 && mDetectEmptyViewSpace) 
-	{   
-		// consider all samples valid
-		// check if the viewpoint lies on the line segment AB
-		if (Distance(pointA, pointB) <
-			Distance(viewPoint, pointA) + Distance(viewPoint, pointB) - Limits::Small) 
-		{
-			validSample = false;
-		}
-	}
-	
-	if (validSample) 
-	{	
-		if (objectA) 
-		{
-			vssRay = new VssRay(pointB,
-								pointA,
-								objectB,
-								objectA,
-								probability,
-								mPass);
-			vssRays.push_back(vssRay);
-			hits ++;
-		}
-
-		if (objectB) 
-		{
-			vssRay = new VssRay(pointA,
-								pointB,
-								objectA,
-								objectB,
-								probability,
-								mPass);
-			vssRays.push_back(vssRay);
-			hits ++;
-		}
-		//Debug << "internal ray: " << *vssRay << endl << endl;
-	}
-//cout << "b";
-	return hits;
+	  return 0;
+  }
+  
+  
+  VssRay *vssRay  = NULL;
+  bool validSample = (objectA != objectB);
+  if (validSample) {
+	if (objectA) {
+	  vssRay = new VssRay(pointB,
+						  pointA,
+						  objectB,
+						  objectA,
+						  mPass,
+						  probability
+						  );
+	  vssRays.push_back(vssRay);
+	  hits ++;
+	}
+	
+	if (objectB) {
+	  vssRay = new VssRay(pointA,
+						  pointB,
+						  objectA,
+						  objectB,
+						  mPass,
+						  probability
+						  );
+	  vssRays.push_back(vssRay);
+	  hits ++;
+	}
+  }
+  
+  return hits;
 }
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj	(revision 1261)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.vcproj	(revision 1272)
@@ -20,5 +20,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="..\include;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost\"
+				AdditionalIncludeDirectories="..\include;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost"
 				PreprocessorDefinitions="WIN32;_DEBUG;_LIB;"
 				MinimalRebuild="TRUE"
@@ -107,10 +107,12 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				Optimization="0"
+				Optimization="3"
+				GlobalOptimizations="TRUE"
 				InlineFunctionExpansion="0"
-				FavorSizeOrSpeed="0"
+				FavorSizeOrSpeed="1"
+				OptimizeForProcessor="3"
 				OptimizeForWindowsApplication="TRUE"
-				AdditionalIncludeDirectories="..\include;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\src;&quot;$(CG_INC_PATH)&quot;;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;&quot;$(BOOST_INCLUDE)&quot;;..\..\Preprocessing\MultiLevelRayTracing"
-				PreprocessorDefinitions="WIN32;NDEBUG;_LIB"
+				AdditionalIncludeDirectories="..\include;&quot;$(QTDIR)\include\QtCore&quot;;&quot;$(QTDIR)\include\QtGui&quot;;&quot;$(QTDIR)\include&quot;;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\..\Preprocessing\MultiLevelRayTracing"
+				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL"
 				ExceptionHandling="TRUE"
 				RuntimeLibrary="2"
@@ -199,9 +201,10 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				Optimization="0"
+				Optimization="3"
 				InlineFunctionExpansion="0"
 				FavorSizeOrSpeed="0"
+				OptimizeForProcessor="3"
 				OptimizeForWindowsApplication="TRUE"
-				AdditionalIncludeDirectories="..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;&quot;$(BOOST_INCLUDE)&quot;;..\MultiLevelRayTracing"
+				AdditionalIncludeDirectories="..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost;..\MultiLevelRayTracing"
 				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;GTP_INTERNAL"
 				ExceptionHandling="TRUE"
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/RssPreprocessor.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/RssPreprocessor.cpp	(revision 1251)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/RssPreprocessor.cpp	(revision 1272)
@@ -86,5 +86,9 @@
 {
   for (int i=0; i < rays.size(); i++) {
-	CastRay(rays[i].mOrigin, rays[i].mDirection, rays[i].mPdf, vssRays, mViewCellsManager->GetViewSpaceBox());
+	CastRay(rays[i].mOrigin,
+			rays[i].mDirection,
+			rays[i].mPdf,
+			vssRays,
+			mViewCellsManager->GetViewSpaceBox());
 	if (i % 10000 == 0)
 	  cout<<".";
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/default.env
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 1248)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/default.env	(revision 1272)
@@ -6,4 +6,6 @@
 Scene {
 
+filename ../data/CityModel/CityModel.obj
+# filename ../data/GrandCanyon/grandcanyon1_RotXmin90.obj
 # filename ../data/glasgow/glasgow1.x3d
 #	filename vienna.x3d
@@ -11,5 +13,5 @@
 #filename ../data/vienna/vienna-buildings.x3d
 #filename ../data/vienna/city1500_flat_1.x3d
-filename ../data/vienna/vienna-buildings.x3d;../data/vienna/vienna-roofs.x3d
+#filename ../data/vienna/vienna-buildings.x3d;../data/vienna/vienna-roofs.x3d
 #;../data/vienna/vienna-plane.x3d;../data/vienna/vienna-roads.x3d
 # filename ../data/vienna/viewcells-25-sel.x3d
@@ -31,6 +33,10 @@
 	# stored sample rays
 	samplesFilename rays.out
-	useGlRenderer true
+	useGlRenderer false
 	useGlDebugger false
+# 0 = INTERNAL 		1 = MLRT
+
+	rayCastMethod 1
+	
 #	type sampling
 #	type vss
@@ -46,5 +52,5 @@
 	visibilityFilterWidth	0.01
 	visibilityFile visibility.xml
-	loadPolygonsAsMeshes false
+	loadPolygonsAsMeshes true
 }
 
@@ -103,7 +109,7 @@
 RssPreprocessor {
 	samplesPerPass 1000
-	initialSamples 2000000
-	vssSamples 30000000
-	vssSamplesPerPass 1000000
+	initialSamples 1000000
+	vssSamples 10000000
+	vssSamplesPerPass 500000
 	useImportanceSampling true
 
@@ -143,7 +149,7 @@
 	maxStaticMemory	100
 
-	splitType regular
+#	splitType regular
 #	splitType heuristic
-#	splitType hybrid
+	splitType hybrid
 	hybridDepth		10
 	splitUseOnlyDrivingAxis false
@@ -187,5 +193,5 @@
 MeshKdTree {
 	Termination {
-		minCost 8
+		minCost 32
 		maxDepth 18
 		maxCostRatio 0.9
@@ -291,4 +297,5 @@
 #	filename ../data/soda/soda5-viewcell-single.xm
 #	filename ../data/soda/vienna-viewcell-single.xml
+	filename ../data/CityModel/CityModel-viewcells-5000.xml
 
 
@@ -298,5 +305,5 @@
 #	filename ../data/vienna/viewcells_vienna2.xml
 #	filename ../data/vienna/vienna_simple-21-04-avs2-viewCells.xml
-	filename ../data/vienna/vienna-viewcells-5000.xml
+#	filename ../data/vienna/vienna-viewcells-5000.xml
 
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.h	(revision 1264)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.h	(revision 1272)
@@ -134,5 +134,5 @@
   
   enum {
-	  INTERNAL_RAYCASTER,
+	  INTERNAL_RAYCASTER = 0,
 	  INTEL_RAYCASTER
   };
@@ -146,5 +146,5 @@
   
   virtual void CastRays(SimpleRayContainer &rays,
-	  VssRayContainer &vssRays) {};
+						VssRayContainer &vssRays) {};
 
   /** Returns a view cells manager with respect to the given name.
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp	(revision 1261)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp	(revision 1272)
@@ -499,4 +499,5 @@
 	if ((int)(leaf->mObjects.size()) > mBvhStats.maxObjectRefs)
 		mBvhStats.maxObjectRefs = (int)leaf->mObjects.size();
+
 }
 
@@ -1593,4 +1594,4 @@
 }
 
-
-}
+}
+
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 1248)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Makefile	(revision 1272)
@@ -1,5 +1,5 @@
 #############################################################################
 # Makefile for building: preprocessor
-# Generated by qmake (2.00a) (Qt 4.1.2) on: po 21. VIII 11:15:08 2006
+# Generated by qmake (2.00a) (Qt 4.1.2) on: út 22. VIII 22:47:13 2006
 # Project:  preprocessor.pro
 # Template: app
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 1264)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 1272)
@@ -1,2 +1,8 @@
+#ifdef GTP_INTERNAL
+//#define USE_QT 0
+#endif
+
+#define USE_BOOST 1
+
 #ifdef UNICODE
 #undef UNICODE
@@ -20,8 +26,16 @@
 #include "ViewCell.h"
 #include "SceneGraph.h"
+
+#if USE_BOOST
 #include "BoostPreprocessorThread.h"
+#endif
+
 #include "RenderSampler.h"
 #include "ResourceManager.h"
 #include "GlRenderer.h"
+
+#if USE_QT
+#include "QtRenderer/QtGlRenderer.h"
+#endif
 
 #define USE_EXE_PATH false
@@ -92,4 +106,17 @@
 
 
+string ReplaceSuffix(string filename,
+					 string a,
+					 string b)
+{
+  string result = filename;
+
+  int pos = filename.rfind(a, filename.size()-1);
+  if (pos == filename.size() - a.size()) {
+	result.replace(pos, a.size(), b);
+  }
+  return result;
+}
+
 int
 main(int argc, char **argv)
@@ -101,8 +128,11 @@
 	//be ignored. Use it as you will!
 	//note: from GDNet Direct [3.8.04 - 3.14.04] void detectMemoryLeaks() {
-	_CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF|_CRTDBG_ALLOC_MEM_DF);
-	_CrtSetReportMode(_CRT_ASSERT,_CRTDBG_MODE_FILE);
-	_CrtSetReportFile(_CRT_ASSERT,_CRTDBG_FILE_STDERR); 
-
+#if 0
+  _CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF|_CRTDBG_ALLOC_MEM_DF);
+  _CrtSetReportMode(_CRT_ASSERT,_CRTDBG_MODE_FILE);
+  _CrtSetReportFile(_CRT_ASSERT,_CRTDBG_FILE_STDERR); 
+#endif
+
+  cerr<<"HERE!\n";
 	int returnCode = 0;
 	
@@ -163,10 +193,12 @@
 	string filename(buff);
 	preprocessor->LoadScene(filename);
-
+	
+	string rayCastFile = ReplaceSuffix(filename, ".obj", ".kdf");
+	
 	//-- initialize external ray casters
-	if (preprocessor->InitRayCast("../data/grandcanyon1_RotXmin90.kdf"))
-	{
+	if (preprocessor->InitRayCast(rayCastFile))
+	  {
 		cout << "ray casting initialized!" << endl;
-	}
+	  }
 	else
 	{
@@ -213,8 +245,9 @@
 
 	// create a preprocessor thread (note: capsulates calls to boost fuctions!)
+	//PreprocessorThread *pt = PreprocessorThreadFactory::Create(preprocessor);
+#if USE_BOOST
 	BoostPreprocessorThread pt(preprocessor);
-
-	//PreprocessorThread *pt = PreprocessorThreadFactory::Create(preprocessor);
-
+#endif
+	
 	bool guiSupported = false;
 	if (preprocessor->mUseGlRenderer || preprocessor->mUseGlDebugger)
@@ -222,10 +255,21 @@
 		cout << "using gl widget" << endl;
 		// create and run the preprocessor application in a parallel thread
+#if USE_BOOST
 		pt.InitThread();
+#endif
 		//pt.RunThread();
 		
 		// display the render widget
-		if (!rendererWidget)
+		if (!rendererWidget) {
+
+#if !USE_QT
 		  guiSupported = LoadMyDll();
+#else
+		  rendererWidget = new QtGlRendererWidget(preprocessor->mSceneGraph,
+												  preprocessor->mViewCellsManager,
+												  preprocessor->mKdTree);
+#endif
+		}
+		
 	  }
 	
@@ -237,5 +281,7 @@
 	if (!(preprocessor->mUseGlRenderer || preprocessor->mUseGlDebugger)) {
 	  // just call the mail method -> will be executed in the main thread
+#if USE_BOOST
 	  pt.Main();
+#endif
 	}
 	
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ObjParser.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ObjParser.cpp	(revision 1233)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ObjParser.cpp	(revision 1272)
@@ -15,4 +15,5 @@
 
 
+
 namespace GtpVisibilityPreprocessor {
 
@@ -48,5 +49,5 @@
 			   map<int, Vector3> &hashTable)
 {
-	cout << "f";
+  //	cout << "f";
 
 	char *pch;
@@ -156,5 +157,5 @@
 	
 	SceneGraphNode *root = new SceneGraphNode;
-	
+	cout<<"HERE2!\n";
 	int meshGrouping;
 	Environment::GetSingleton()->GetIntValue("ObjParser.meshGrouping", meshGrouping);
@@ -167,5 +168,5 @@
 			{
 				float x,y,z;
-				cout << "v";
+				//cout << "v";
 
 				// vertex 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.icproj
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.icproj	(revision 1272)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/TestPreprocessor.icproj	(revision 1272)
@@ -0,0 +1,262 @@
+<?xml version="1.0" encoding="Windows-1252"?>
+<VisualStudioProject 
+	ProjectType="Intel C++ Project"
+	Version="9.0"
+	Name="TestPreprocessor"
+	ProjectGUID="{2BF1B1A6-D665-472B-B1B1-E172512D66C1}"
+	Keyword="Win32Proj"
+	VCNestedProjectGUID="{69BC58F0-C7EB-4B43-B782-B6F047EF0528}"
+	VCNestedProjectFileName="TestPreprocessor.vcproj">
+	<Platforms>
+		<Platform 
+			Name="Win32"/>
+	</Platforms>
+	<Configurations>
+		<Configuration 
+			Name="Debug|Win32">
+			<Tool 
+				Name="GeneralTool"
+				OutputDirectory="..\bin\Debug"
+				IntermediateDirectory="..\obj\Debug"
+				ConfigurationType="1"
+				CharacterSet="2"/>
+			<Tool 
+				Name="CppCmplrTool"
+				Optimization="0"
+				AdditionalIncludeDirectories="..\include;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\..\..\..\..\NonGTP\Boost"
+				PreprocessorDefinitions="WIN32;_DEBUG;_CONSOLE"
+				MinimalRebuild="TRUE"
+				BasicRuntimeChecks="3"
+				RuntimeLibrary="3"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="4"/>
+			<Tool 
+				Name="CustomTool"/>
+			<Tool 
+				Name="LinkerTool"
+				AdditionalDependencies="xerces-c_2D.lib zdll.lib zziplibd.lib devil.lib glut32.lib OpenGL32.Lib glu32.lib Preprocessor.lib glew32.lib"
+				OutputFile="$(OutDir)/Preprocessor.exe"
+				LinkIncremental="2"
+				AdditionalLibraryDirectories="..\include;..\src\GL;&quot;..\lib\$(ConfigurationName)&quot;;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib"
+				GenerateDebugInformation="TRUE"
+				ProgramDatabaseFile="$(OutDir)/TestPreprocessor.pdb"
+				SubSystem="1"
+				TargetMachine="1"/>
+			<Tool 
+				Name="MidlCmplrTool"/>
+			<Tool 
+				Name="PostBuildEventTool"/>
+			<Tool 
+				Name="PreBuildEventTool"/>
+			<Tool 
+				Name="PreLinkEventTool"/>
+			<Tool 
+				Name="ResCmplrTool"/>
+			<Tool 
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool 
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool 
+				Name="VCWebDeploymentTool"/>
+			<Tool 
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool 
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration 
+			Name="Release|Win32">
+			<Tool 
+				Name="GeneralTool"
+				OutputDirectory="..\bin\Release"
+				IntermediateDirectory="..\obj\Release"
+				ConfigurationType="1"
+				CharacterSet="2"/>
+			<Tool 
+				Name="CppCmplrTool"
+				Optimization="0"
+				AdditionalIncludeDirectories="..\include;..\..\..\..\..\..\NonGTP\Boost;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\MultiLevelRayTracing"
+				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE"
+				RuntimeLibrary="2"
+				RuntimeTypeInfo="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool 
+				Name="CustomTool"/>
+			<Tool 
+				Name="LinkerTool"
+				AdditionalDependencies="xerces-c_2.lib glew32.lib zdll.lib zziplib.lib devil.lib glut32.lib OpenGL32.Lib glu32.lib Preprocessor.lib"
+				OutputFile="$(OutDir)/Preprocessor.exe"
+				LinkIncremental="1"
+				AdditionalLibraryDirectories="..\src\GL;..\lib\release;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib"
+				GenerateDebugInformation="FALSE"
+				SubSystem="1"
+				OptimizeReferences="2"
+				EnableCOMDATFolding="2"
+				TargetMachine="1"
+				FixedBaseAddress="1"/>
+			<Tool 
+				Name="MidlCmplrTool"/>
+			<Tool 
+				Name="PostBuildEventTool"/>
+			<Tool 
+				Name="PreBuildEventTool"/>
+			<Tool 
+				Name="PreLinkEventTool"/>
+			<Tool 
+				Name="ResCmplrTool"/>
+			<Tool 
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool 
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool 
+				Name="VCWebDeploymentTool"/>
+			<Tool 
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool 
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration 
+			Name="mlrt|Win32">
+			<Tool 
+				Name="GeneralTool"
+				OutputDirectory="$(ConfigurationName)"
+				IntermediateDirectory="$(ConfigurationName)"
+				ConfigurationType="1"
+				CharacterSet="2"/>
+			<Tool 
+				Name="CppCmplrTool"
+				Optimization="3"
+				GlobalOptimizations="TRUE"
+				FavorSizeOrSpeed="1"
+				OptimizeForProcessor="3"
+				AdditionalIncludeDirectories="..\include;..\..\..\..\..\..\NonGTP\Boost;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces;..\..\MultiLevelRayTracing"
+				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL"
+				RuntimeLibrary="2"
+				RuntimeTypeInfo="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool 
+				Name="CustomTool"/>
+			<Tool 
+				Name="LinkerTool"
+				AdditionalDependencies="xerces-c_2.lib glew32.lib zdll.lib zziplib.lib devil.lib glut32.lib OpenGL32.Lib glu32.lib cg.lib cgGL.lib Preprocessor.lib RTWorld.lib RTScene.lib"
+				OutputFile="$(OutDir)/Preprocessor.exe"
+				LinkIncremental="1"
+				AdditionalLibraryDirectories="..\src\mlrt;&quot;$(CG_LIB_PATH)&quot;;..\src\GL;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;..\..\Preprocessing\MultiLevelRayTracing\RTScene\Release;..\..\Preprocessing\MultiLevelRayTracing\RTWorld\Release"
+				GenerateDebugInformation="FALSE"
+				SubSystem="1"
+				OptimizeReferences="2"
+				EnableCOMDATFolding="2"
+				TargetMachine="1"
+				FixedBaseAddress="1"/>
+			<Tool 
+				Name="MidlCmplrTool"/>
+			<Tool 
+				Name="PostBuildEventTool"/>
+			<Tool 
+				Name="PreBuildEventTool"/>
+			<Tool 
+				Name="PreLinkEventTool"/>
+			<Tool 
+				Name="ResCmplrTool"/>
+			<Tool 
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool 
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool 
+				Name="VCWebDeploymentTool"/>
+			<Tool 
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool 
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+		<Configuration 
+			Name="Release Internal|Win32">
+			<Tool 
+				Name="GeneralTool"
+				OutputDirectory="bin\Release"
+				IntermediateDirectory="bin\Release"
+				ConfigurationType="1"
+				CharacterSet="2"/>
+			<Tool 
+				Name="CppCmplrTool"
+				Optimization="3"
+				AdditionalIncludeDirectories="..\include;..\..\..\..\..\..\NonGTP\Boost;&quot;$(QTDIR)\include\QtOpenGl&quot;;..\src;..\..\..\..\..\..\NonGTP\Devil\include;..\..\..\..\..\..\NonGTP\Zlib\include;..\..\..\..\..\..\NonGTP\Xerces"
+				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;GTP_INTERNAL"
+				RuntimeLibrary="2"
+				RuntimeTypeInfo="TRUE"
+				UsePrecompiledHeader="0"
+				WarningLevel="3"
+				Detect64BitPortabilityProblems="TRUE"
+				DebugInformationFormat="3"/>
+			<Tool 
+				Name="CustomTool"/>
+			<Tool 
+				Name="LinkerTool"
+				AdditionalDependencies="xerces-c_2.lib glew32.lib zdll.lib zziplib.lib devil.lib glut32.lib OpenGL32.Lib glu32.lib Preprocessor.lib RTScene.lib RTWorld.lib"
+				OutputFile="../bin/release/Preprocessor.exe"
+				LinkIncremental="1"
+				AdditionalLibraryDirectories="..\src\GL;..\lib\release;..\..\Preprocessing\lib\release;..\..\..\..\..\..\NonGTP\Boost\lib;..\..\..\..\..\..\NonGTP\Xerces\xercesc\lib;..\..\..\..\..\..\NonGTP\Zlib\lib;..\..\..\..\..\..\NonGTP\Devil\lib;..\MultiLevelRayTracing\RTScene\Release;..\MultiLevelRayTracing\RTWorld\Release"
+				GenerateDebugInformation="FALSE"
+				SubSystem="1"
+				OptimizeReferences="2"
+				EnableCOMDATFolding="2"
+				TargetMachine="1"
+				FixedBaseAddress="1"/>
+			<Tool 
+				Name="MidlCmplrTool"/>
+			<Tool 
+				Name="PostBuildEventTool"/>
+			<Tool 
+				Name="PreBuildEventTool"/>
+			<Tool 
+				Name="PreLinkEventTool"/>
+			<Tool 
+				Name="ResCmplrTool"/>
+			<Tool 
+				Name="VCWebServiceProxyGeneratorTool"/>
+			<Tool 
+				Name="VCXMLDataGeneratorTool"/>
+			<Tool 
+				Name="VCWebDeploymentTool"/>
+			<Tool 
+				Name="VCManagedWrapperGeneratorTool"/>
+			<Tool 
+				Name="VCAuxiliaryManagedWrapperGeneratorTool"/>
+		</Configuration>
+	</Configurations>
+	<References>
+	</References>
+	<Files>
+		<Filter 
+			Name="Source Files"
+			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm;asmx"
+			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}">
+			<File 
+				RelativePath="..\src\main.cpp">
+			</File>
+		</Filter>
+		<Filter 
+			Name="Header Files"
+			Filter="h;hpp;hxx;hm;inl;inc;xsd"
+			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}">
+		</Filter>
+		<Filter 
+			Name="Resource Files"
+			Filter="rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe;resx"
+			UniqueIdentifier="{67DA6AB6-F800-4c08-8B7A-83BB121AAD01}">
+		</Filter>
+		<File 
+			RelativePath=".\VTune\TestPreprocessor.vpj">
+		</File>
+	</Files>
+	<Globals>
+	</Globals>
+</VisualStudioProject>
+
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 1248)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/preprocessor.pro	(revision 1272)
@@ -3,4 +3,5 @@
 
 TEMPLATE = app
+
 
 TARGET = preprocessor
@@ -31,4 +32,11 @@
 CONFIG(qt) {
 win32:LIBPATH += "d:/Programs/NVIDIA Corporation/Cg/lib"
+CONFIG(debug) {
+LIBPATH += QtRenderer/debug
+}
+
+CONFIG(release) {
+LIBPATH += QtRenderer/release
+}
 }
 
@@ -46,11 +54,19 @@
 }
 
-win32:LIBS += xerces-c_2.lib devil.lib ilu.lib ilut.lib \
-glew32.lib zlib.lib 
+win32:LIBS += devil.lib ilu.lib ilut.lib glew32.lib zlib.lib zdll.lib zziplibd.lib
+
+CONFIG(release) {
+win32:LIBS += xerces-c_2.lib 
+}
+
+CONFIG(debug) {
+win32:LIBS += xerces-c_2D.lib 
+}
 
 QMAKE_LFLAGS_CONSOLE=/NODEFAULTLIB:LIBCMT
 
 CONFIG(qt) {
-win32:LIBS += cg.lib cgGL.lib 
+win32:LIBS += cg.lib cgGL.lib
+LIBS += QtRenderer.lib
 }
 
@@ -76,7 +92,8 @@
 GzBinFileInputStream.cpp  GzFileInputSource.cpp \
 LogManager.cpp \
-SamplingStrategy.cpp KdIntersectable.cpp BoostPreprocessorThread.cpp \
-OspTree.cpp HierarchyManager.cpp ObjParser.cpp VspTree.cpp BvHierarchy.cpp 
-
+SamplingStrategy.cpp KdIntersectable.cpp \
+OspTree.cpp HierarchyManager.cpp ObjParser.cpp VspTree.cpp \
+BvHierarchy.cpp  \
+BoostPreprocessorThread.cpp 
 
 
@@ -85,3 +102,2 @@
 }
 
-#VspKdTree.cpp ResourceManager.cpp 
